Career/Controllers/ApplicationController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Career.Data.Entities;
using Career.Models.ViewModels;
using Career.Services;
using Career.Utilities;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace Career.Controllers
{
    [Authorize]
    public class ApplicationController : Controller
    {
        private readonly ApplicantService applicantService;
        [TempData]
        public string ResultMessage { get; set; }
        [TempData]
        public string RResult { get; set; }
        public ApplicationController(ApplicantService applicantService)
        {
            this.applicantService = applicantService;
        }
        public IActionResult Index()
        {
            return View(applicantService.Applicants());
        }
        public IActionResult Apply()
        {
            return View();
        }
        [HttpPost]
        public IActionResult Apply(ApplicantVM applicantVM)
        {
            if (ModelState.IsValid)
            {
                var applicant = new Applicant() 
                { 
                    Firstname = applicantVM.Firstname?.ToUpper(),
                    Lastname = applicantVM.Lastname?.ToUpper(),
                    Middlename = applicantVM.Middlename?.ToUpper(),
                    DateOfBirth = applicantVM.DateOfBirth,
                    Religion = applicantVM.Religion,
                    Nationality = applicantVM.Nationality,
                };

                var result = applicantService.AddApplicant(applicant);
                RResult = JsonConvert.SerializeObject(result);

                if (result.Succeeded)
                {                    
                    return RedirectToAction(nameof(Index));
                }
                return View();
            }
            return View(applicantVM);
        }
        public IActionResult Edit(int id)
        {
            var applicant = applicantService.Applicant(id);
            if(applicant != null)
            {
                return View(new EditApplicantVM {
                    ApplicantID = applicant.ApplicantID,
                    Firstname = applicant.Firstname,
                    Lastname = applicant.Lastname,
                    Middlename = applicant.Middlename,
                    DateOfBirth = applicant.DateOfBirth,
                    Religion = applicant.Religion,
                    Nationality = applicant.Nationality,
                });
            }
            ResultMessage = Constants.ApplicantNotFound;
            return RedirectToAction(nameof(Index));
        }
        [HttpPost]
        public IActionResult Edit(EditApplicantVM applicantVM)
        {
            if (ModelState.IsValid)
            {
                var applicant = new Applicant()
                {
                    ApplicantID = applicantVM.ApplicantID,
                    Firstname = applicantVM.Firstname?.ToUpper(),
                    Lastname = applicantVM.Lastname?.ToUpper(),
                    Middlename = applicantVM.Middlename?.ToUpper(),
                    DateOfBirth = applicantVM.DateOfBirth,
                    Religion = applicantVM.Religion,
                    Nationality = applicantVM.Nationality,
                    EmailAddress = applicantVM.EmailAddress
                };

                var result = applicantService.Update(applicant);
                RResult = JsonConvert.SerializeObject(result);

                if (result.Succeeded)
                {
                    return RedirectToAction(nameof(Index));
                }
            }
            return View(applicantVM);
        }
        public IActionResult Details(int id)
        {
            var applicant = applicantService.ApplicantWithApplications(id);
            if (applicant != null)
            {
                return View(new EditApplicantVM
                {
                    ApplicantID = applicant.ApplicantID,
                    Firstname = applicant.Firstname,
                    Lastname = applicant.Lastname,
                    Middlename = applicant.Middlename,
                    DateOfBirth = applicant.DateOfBirth,
                    Religion = applicant.Religion,
                    Nationality = applicant.Nationality,
                    ApplicationDate = applicant.RegistredDate,
                    Applications = applicant.Applications.ToList()
                });
            }
            ResultMessage = Constants.ApplicantNotFound;
            return RedirectToAction(nameof(Index));
        }
        [HttpPost]
        public IActionResult Delete(int applicantID)
        {
            var result = applicantService.Delete(applicantID);
            RResult = JsonConvert.SerializeObject(result);

            if (result.Succeeded)
            {
                return RedirectToAction(nameof(Index));
            }
            return RedirectToAction(nameof(Details),new { id = applicantID });
        }
        [HttpPost]
        public IActionResult ApplyPosition(int applicantID, string positionCode)
        {
            if(positionCode != null)
            {
                var result = applicantService.ApplyPosition(applicantID, positionCode);
                RResult = JsonConvert.SerializeObject(result);
            }
            else
            {
                ResultMessage = Constants.UnexpectedFormError;
            }
            return RedirectToAction(nameof(OpenPositionController.Index),nameof(OpenPositionController).Replace("Controller",""),new { applicantID });
        }
    }
}

Career/Controllers/OpenPositionController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Career.Data.Entities;
using Career.Models.ViewModels;
using Career.Services;
using Career.Utilities;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace Career.Controllers
{
    //[Authorize]
    public class OpenPositionController : Controller
    {
        private readonly OpenPositionService openPositionService;
        [TempData]
        public string ResultMessage { get; set; }
        [TempData]
        public string RResult { get; set; }
        public OpenPositionController(OpenPositionService openPositionService)
        {
            this.openPositionService = openPositionService;
        }
        public IActionResult Index(int? applicantID)
        {
            return View(openPositionService.OpenPositions());
        }
        public IActionResult Add()
        {
            return View();
        }
        [HttpPost]
        public IActionResult Add(OpenPositionVM openPositionVM)
        {
            if (ModelState.IsValid)
            {
                var applicant = new OpenPosition() 
                { 
                    PositionCode = openPositionVM.PositionCode.ToUpper(),
                    Title = openPositionVM.Title,
                    Responsibilities = openPositionVM.Responsibilities,
                    TargetApplicants = openPositionVM.TargetApplicants
                };

                var result = openPositionService.AddOpenPosition(applicant);
                RResult = JsonConvert.SerializeObject(result);

                if (result.Succeeded)
                {                    
                    return RedirectToAction(nameof(Index));
                }
                return View();
            }
            return View(openPositionVM);
        }
        public IActionResult Edit(string id)
        {
            var applicant = openPositionService.OpenPosition(id);
            if(applicant != null)
            {
                return View(new OpenPositionVM
                {
                    PositionCode = applicant.PositionCode,
                    Title = applicant.Title,
                    Responsibilities = applicant.Responsibilities,
                    TargetApplicants = applicant.TargetApplicants
                });
            }
            ResultMessage = Constants.PositionNotFound;
            return RedirectToAction(nameof(Index));
        }
        [HttpPost]
        public IActionResult Edit(OpenPositionVM openPositionVM)
        {
            if (ModelState.IsValid)
            {
                var openPosition = new OpenPosition()
                {
                    PositionCode = openPositionVM.PositionCode,
                    Title = openPositionVM.Title,
                    Responsibilities = openPositionVM.Responsibilities,
                    TargetApplicants = openPositionVM.TargetApplicants
                };

                var result = openPositionService.Update(openPosition);
                RResult = JsonConvert.SerializeObject(result);

                if (result.Succeeded)
                {
                    return RedirectToAction(nameof(Index));
                }
            }
            return View(openPositionVM);
        }
        public IActionResult Details(string id)
        {
            var openPosition = openPositionService.OpenPosition(id);
            if (openPosition != null)
            {
                return View(new OpenPositionVM
                {
                    PositionCode = openPosition.PositionCode,
                    Title = openPosition.Title,
                    Responsibilities = openPosition.Responsibilities,
                    TargetApplicants = openPosition.TargetApplicants
                });
            }
            ResultMessage = Constants.PositionNotFound;
            return RedirectToAction(nameof(Index));
        }
        [HttpPost]
        public IActionResult Delete(string positionCode)
        {
            if(positionCode != null)
            {
               var result = openPositionService.Delete(positionCode);
                RResult = JsonConvert.SerializeObject(result);

                if (result.Succeeded)
                {
                    return RedirectToAction(nameof(Index));
                }
                return RedirectToAction(nameof(Details),new { id = positionCode });
            }
            ResultMessage = Constants.PositionNotFound;
            return RedirectToAction(nameof(Index));
        }
    }
}

Career/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Careers</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link href="~/font-awesome/css/all.css" rel="stylesheet" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">HRIS Careers</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse ">
                    <ul class="navbar-nav ml-auto">
                        @if (User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-controller="Account" asp-action="Logout">Logout, @User.Identity.Name</a>
                            </li>
                        }
                    </ul>
                    <ul class="navbar-nav">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Application" asp-action="Index">Applicants</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="OpenPosition" asp-action="Index">Opened Positions</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle text-dark" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Dropdown
                            </a>
                            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <a class="dropdown-item" href="#">Action</a>
                                <a class="dropdown-item" href="#">Another action</a>
                                <div class="dropdown-divider"></div>
                                <a class="dropdown-item" href="#">Something else here</a>
                            </div>
                        </li>
                    </ul>

                </div>
            </div>
        </nav>
    </header>
    <div class="container-fluid">
        <main role="main" class="pb-3">
            <partial name="_RResult" />
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container-fluid">
            &copy; 2019 - Career - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
    @RenderSection("ValidationScripts", false)

</body>
</html>

Career/Views/Shared/_RResult.cshtml
@{
    var rResultJson = TempData["RResult"] as string;
    string message = TempData["ResultMessage"] as string;
}

@if (rResultJson != null)
{
    var rResult = Newtonsoft.Json.JsonConvert.DeserializeObject<Career.Utilities.RResult>(rResultJson);
    <div class="@rResult.AlertResult()" role="alert">
        @rResult.Message
    </div>
}

@if (message != null)
{
    <div class="alert alert-secondary" role="alert">
        @message
    </div>
}